package 
{
  import flash.display.BitmapData;
  import flash.display.Graphics;
  import flash.display.Sprite;
  import flash.display.StageScaleMode;
  import flash.events.Event;
  import flash.events.KeyboardEvent;
  import flash.events.MouseEvent;
  import flash.filters.BlurFilter;
  import flash.geom.Matrix;
  import flash.geom.Point;
  import flash.geom.Rectangle;
  import flash.media.Sound;
  import flash.ui.Keyboard;
  import flash.ui.Mouse;
  import flash.utils.Dictionary;


	public class Main extends xGame 
	{

		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
  
    
    [Embed(source = "mickey.jpg")]  private static var embedPicMickey:Class;
    [Embed(source = "foam.png")]    private static var embedPicFoam:Class;
        
    [Embed(source = "PROPFLY.mp3")] private static var embedSndShaver:Class;
    
    
    [Embed(source = "minifont8.png")]  private static var embedFontPic8:Class;
    [Embed(source = "minifont8.xfnt", mimeType = "application/octet-stream")]
    private static var embedFont8:Class;
    public var myAdvFont:xAdvFont;
    
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
      
      stage.quality = "LOW";
      stage.scaleMode = StageScaleMode.NO_SCALE;

      Mouse.hide();
 
      myAdvFont = new xAdvFont();
      myAdvFont.loadFont(embedFont8, embedFontPic8);

      mySound2 = new xSoundMan();

      
       //mySound2.dictSnd[wname] = (new embed) as Sound;
        //xMusMan.playMus(mySound2.getSound(wmus));
     //  dictPic["backdrop"] = (new embedPicBackdrop).bitmapData;

        dictPic["mickey"] = (new embedPicMickey).bitmapData;
        dictPic["foam"] = (new embedPicFoam).bitmapData;

        mySound2.dictSnd["shaver"] =  (new embedSndShaver) as Sound; 
        
        xMusMan.playMus(mySound2.getSound("shaver"));
        xMusMan.pauseMus();
        
    //  drawImageSpr(graphics, (new embedStart).bitmapData, 0, 0, false, false);
        
    //  filters = [ new BlurFilter() ];
    
       
      stage.addEventListener(MouseEvent.MOUSE_DOWN, onMdown);
      stage.addEventListener(MouseEvent.MOUSE_UP, onMup);
      stage.addEventListener(KeyboardEvent.KEY_DOWN, onKdown);
      stage.addEventListener(KeyboardEvent.KEY_UP, onKup);
      stage.addEventListener(Event.ENTER_FRAME, onEnter);   
		}//init
   
 
    public var dictPic:Dictionary = new Dictionary();
    public function getData(wname:String):BitmapData { return dictPic[wname]; }
    
    public var mySound2:xSoundMan;
    public function playSound(wname:String, vm:Number = 1.0, pan:Number = 0.0):void 
    {  mySound2.playSound(wname, vm, 0);  }
  


    public function onEnter(e:Event):void
    {  
       graphics.clear();
      
       drawImageSpr(graphics, getData("mickey"), 0, 0, false, false);
       drawImageSpr(graphics, getData("foam"), 0, 0, false, false);
       
       
       if (mbutton > 0 ) { xMusMan.contMus(); }
      else { xMusMan.pauseMus(); }
       
      mx = stage.mouseX; my = stage.mouseY;
      
     
       graphics.lineStyle(2, 0, mbutton==0?0.2:0.01);
       graphics.drawCircle(mx, my, 32);
   
      
      if (mbutton > 0 )
      {
        drawCirc(getData("foam"), mx, my, 24, 0.1, 0);
      }//endif
     
       gt += 1;
       keyTime += 1;
    }//onenter
    
    
      
    //wonderfl dUBq
    
    public function drawCirc(to:BitmapData, ax:Number, ay:Number, r:Number, u:Number=0.2, c:uint=0):void
    {
       var ang:Number;       var kx:Number; var ky:Number;       var kx2:Number; var ky2:Number;
        
       //graphics.drawCircle(ax,ay, r);
        
       for (ang = -1.57; ang < 1.57; ang+= u)
       {
         //graphics.drawCircle(ax+Math.cos(ang)*r, ay+Math.sin(ang)*r, 4);   
         kx = ax + Math.cos(ang) *r;
         ky = ay + Math.sin(ang) *r;
         kx2 = ax + Math.cos(ang+u) *r;
         ky2 = ay + Math.sin(ang+u) *r;
        fillRect(to, ax - ((ang < 0?kx2:kx) - ax), ky, ((ang < 0?kx2:kx) - ax) * 2, ky2 - ky+1, c);
       }//nextang
        
    }//drawcirc 
 

 
  }//classend
}


