package  
{
  import flash.display.BitmapData;
  import flash.display.BlendMode;
  import flash.display.Graphics;
  import flash.geom.ColorTransform;
  import flash.geom.Matrix;
  import flash.geom.Point;

  public class xAdvFont
  {
    
    public var vecChar:Vector.<xChar2>;
    public var skinName:String = "none";
    public var pic:BitmapData;
    public var chwidth:Number = 0;
    public var chheight:Number = 0;
    public var size:Number = 0;
    public var ascent:Number  = 0;
    public var descent:Number = 0;
    public var linegap:Number = 0;
    
    public var imgwidth:Number = 0;
    public var imgheight:Number = 0;
    
    public var extraSpace:Number = 0;
    
    public var averageWidth:Number = 0;

    
    public var tempDp:Point = new Point();
    public function loadAscii(dat:BitmapData, fw:int, fh:int, sch:int = 0):void
    {
      var nw:int;      var nh:int;      var num:int;      var a:xChar2;
      var i:int; var k:int; var yt:int;
      
      pic = dat;
      
      nw = dat.width / fw;
      nh = dat.height / fh;
      
      chwidth = fw;     chheight = fh;
      linegap = 0;
      ascent = fh;
      descent = 0;
      
      averageWidth = fw;
      
      num = nw * nh;
      
      vecChar = new Vector.<xChar2>(512, false);
      tempDp.x = 0; tempDp.y = 0;
      
      for (i = 0; i < nh; i++) 
      { yt = i * nw;
        for (k  = 0; k < nw; k++)
        {
          a = new xChar2();        vecChar[yt+k + sch] = a;
           a.valid = 1;
           a.rect.x = k * fw; a.rect.y = i * fh;
           a.rect.width = fw; a.rect.height = fh;
           
           a.width = fw;           a.height = fh;
           
           a.sprite = new BitmapData(fw, fh, true, 0);
           a.sprite.copyPixels(dat, a.rect, tempDp); 
           
           a.addx = fw;
           a.ox = 0; a.oy = 0 -fh;
           
        }//nextk
      }//nexti
    }//loadascii
    
    
    //scaling somehow screws it up i guess
    //so thats one feature that can go
    public function loadFont(embedFont:Class, embedPic:Class):void
    {
      var xm:XML;
      var m:XML;
      var a:xChar2;
      
      pic = (new embedPic).bitmapData;
      
      xm = new XML((new embedFont));
      
      
      skinName = xm.@image;
      
      //imgwidth = xm.@w;
      //imgheight = xm.@h;
      imgwidth = pic.width;      imgheight = pic.height;
      
      ascent = xm.@ascent;      descent = xm.@descent;      linegap = xm.@linegap;
      
      chwidth = xm.@size;      chheight = xm.@size;      size = xm.@size;
      
      extraSpace = xm.@extraspace;

      
      vecChar = new Vector.<xChar2>(512, false);
      
      var c:int;
      var ax:Number;
      var ay:Number;
      
      var nchar:Number;
      
      averageWidth = 0;
      nchar = 0;
      
      for each (m in xm.*)
      {
        a = new xChar2();
        
        c = m.@c;
        
        if (c >= 512) { continue; }
        if (c < 0) { continue; }
        vecChar[c] = a;
        
        a.rect.x = m.@x;
        a.rect.y = m.@y;
        a.rect.width = m.@w;
        a.rect.height = m.@h;
        
        
        a.ox = m.@ox;
        a.oy = m.@oy;
        a.addx = m.@addx;
        
        a.width = m.@w;
        a.height = m.@h;
        
        ax = m.@x;
        ay = m.@y;
        
        
        //calc average width
        nchar += 1;
        averageWidth += a.addx;
        

        
        //todo -- in the original these should refer to the middle of the texel
        //so add/sub  (1/imgwidth)*0.5;
        a.u0 = ax / imgwidth;
        a.u1 = (ax+a.width) / imgwidth;
             
        a.v0 = 1.0 - (ay / imgheight);
        a.v1 = a.v0 - (a.height/ imgheight);
        
        
        a.sprite = new BitmapData(a.width, a.height, true, 0);
        tempPnt.x = 0; tempPnt.y = 0;
        a.sprite.copyPixels(pic, a.rect, tempPnt, null, null, true);
        
      }//nextm
      
      averageWidth /= nchar;
      //trace("avgwidth ", averageWidth);
      
    }//loadfont
   

    //todo -- set alpha for writestr
    public var tempCtrans:ColorTransform = new ColorTransform();

    public var tempMat:Matrix = new Matrix();
    public var tempPnt:Point = new Point();
    public function writeStr(to:BitmapData, cx:Number, cy:Number, str:String, alt:BitmapData=null, align:int=0, drawAlpha:Number=1.0):void
    {
      var dx:Number;    var dy:Number;    var ax:Number;    var ay:Number;
      var aw:Number;    var ah:Number;    var i:int;    var num:int;
      var c:int;    var addy:Number;      var dp:Point;      var a:xChar2;
      var mat:Matrix;      var coltrans:ColorTransform;

      coltrans = tempCtrans;
      mat = tempMat;
      mat.identity();     
      tempCtrans.alphaMultiplier = drawAlpha;
      
      if (alt == null) { alt = pic; }
      
  
      
      if (align == 1) { cx -= getWidth(str) * 0.5; }
      
      dp = tempPnt;
      
      addy = (ascent - descent + linegap);
      dx = cx;
      dy = cy + addy; 
      
      num = str.length;
      
      for (i = 0; i < num; i++)
      {
      
        c = str.charCodeAt(i);
        if (c == 10 || c == 13) { dx = cx; dy += addy;  continue;} //enter
        if (c == 32) { dx += (extraSpace  + chwidth / 2); continue; } //space
        a = vecChar[c];
        if (a == null) { dx += chwidth;  continue; } //skip invalid chars

       //  ax = x + (a->ox*scale);
       //  ay = y + (a->oy*scale); //+ a->addy*scale;
       //  aw = a->width*scale;
       //  ah = a->height*scale;
       
        if (drawAlpha < 1)
        {
          mat.tx = dx + a.ox;
          mat.ty = dy + a.oy;
   
          to.draw(a.sprite, mat, coltrans, null, null, false);
          dx += a.addx; 
          continue;
        }//endif
        
        dp.x = dx+a.ox;
        dp.y = dy+a.oy;
        
        to.copyPixels(alt, a.rect, dp, null, null, true);
       
        dx += a.addx;
      }//nexti
      
    }//writestr
    
    
    
    
    
    public function writeStrSpr(g:Graphics, cx:Number, cy:Number, str:String, alt:BitmapData=null, align:int=0, smooth:Boolean=false):void
    {
      var dx:Number;    var dy:Number;    var ax:Number;    var ay:Number;
      var aw:Number;    var ah:Number;    var i:int;    var num:int;
      var c:int;    var addy:Number;
      var dp:Point;
      var a:xChar2;
      //var alt:BitmapData;
      
      if (alt == null) { alt = pic; }
      
      if (align == 1) { cx -= getWidth(str) * 0.5; }
      
      dp = tempPnt;
      
      addy = (ascent - descent + linegap);
      dx = cx;
      dy = cy + addy; 
      
      num = str.length;

        tempMat.identity();

      //g.lineStyle(2, 0);
      for (i = 0; i < num; i++)
      {
      
        c = str.charCodeAt(i);
        if (c == 10 || c == 13) { dx = cx; dy += addy;  continue;} //enter
        if (c == 32) { dx += (chwidth / 2); continue; } //space
        a = vecChar[c];
        if (a == null) { dx += chwidth;  continue; } //skip invalid chars

        //dp.x = dx+a.ox;
        //dp.y = dy+a.oy;
        
        //to.copyPixels(alt, a.rect, dp, null, null, true);

          tempMat.tx = dx + a.ox;
          tempMat.ty = dy + a.oy;
          g.beginBitmapFill(a.sprite, tempMat, false, false);
            g.drawRect(tempMat.tx, tempMat.ty, a.width, a.height);
          g.endFill();
          
        dx += a.addx;
      }//nexti
      
    }//writestrspr
    
    
    
    
    public function getHorizFromCharNo(str:String, ch:int):Number
    {
      var dx:Number;    var dy:Number;    var ax:Number;    var ay:Number;
      var aw:Number;    var ah:Number;    var i:int;     var num:int;
      var c:int;    var addy:Number;      var dp:Point;  var a:xChar2;
           
      addy = (ascent - descent + linegap);      dx = 0;      dy = 0 + addy;       
      num = str.length;      
      if (num > ch) { num = ch; }
      if (num <= 0) { return 0; }
      for (i = 0; i < num; i++)
      {
        c = str.charCodeAt(i);
        if (c == 10 || c == 13) { dx = 0; dy += addy;  continue;} //enter
        if (c == 32) { dx += (extraSpace + chwidth / 2); continue; } //space
        a = vecChar[c];
        if (a == null) { dx += chwidth;  continue; } //skip invalid chars
        dx += a.addx;
      }//nexti
      if (i >= str.length) { dx -= a.addx; dx += (chwidth / 2); }
      return dx;
    }//gethorizcharno
    
    
    //these values are only for this method 
    //(because making pointers for a number is not something you can do in flash)
    public var lastHoriz_charno:int = 0;
    public var lastHoriz_coord:Number = 0;
    public function getCharHoriz(str:String, ax:Number):int
    {
      var ret:Number;
      var dx:Number;    var dy:Number;    var ax:Number;    var ay:Number;
      var aw:Number;    var ah:Number;    var i:int;     var num:int;
      var c:int;    var addy:Number;      var dp:Point;  var a:xChar2;
           
      addy = (ascent - descent + linegap);      dx = 0;      dy = 0 + addy;       
      num = str.length;      
      ret = 0;
      
      for (i = 0; i < num; i++)
      {
      
        c = str.charCodeAt(i);
        if (c == 10 || c == 13) { dx = 0; dy += addy;  continue;} //enter
        if (c == 32) { dx += (extraSpace + chwidth / 2); continue; } //space
        a = vecChar[c];
        if (a == null) { dx += chwidth;  continue; } //skip invalid chars
        dx += a.addx;

        if (dx > ax)
        {
          lastHoriz_charno = i;
          lastHoriz_coord = dx - a.addx;
          return i; 
        
        }
      }//nexti
       
      lastHoriz_charno = i;
      if (a == null) { lastHoriz_coord = 0; }
      else { lastHoriz_coord = dx - a.addx + (chwidth / 2); } 
      return i;
    }//getcharhoriz
    
   
    
    //same as drawstr but return only the width of text for centering
    //todo -- get height of text (?)
    public function getWidth(str:String):Number
    {
      var ret:Number;
      var dx:Number;    var dy:Number;    var ax:Number;    var ay:Number;
      var aw:Number;    var ah:Number;    var i:int;    var num:int;
      var c:int;    var addy:Number;
      var dp:Point;
      var a:xChar2;
      
      //todo -- only works right because i got a monospace font thing
      //calculate average addx or something (?)
      if (str.indexOf("\n") == -1) {return str.length * averageWidth; }
      
      addy = (ascent - descent + linegap);
      dx = 0;
      dy = 0 + addy; 
      
      num = str.length;
      
      ret = 0;
      
      for (i = 0; i < num; i++)
      {
      
        c = str.charCodeAt(i);
        if (c == 10 || c == 13) { dx = 0; dy += addy;  continue;} //enter
        if (c == 32) { dx += (extraSpace + chwidth / 2); continue; } //space
        a = vecChar[c];
        if (a == null) { dx += chwidth;  continue; } //skip invalid chars
        dx += a.addx;
        
        if (ret < dx) { ret = dx; }
      }//nexti
      return ret;
    }//getrect
    
    
      
    public function getCharData(c:int):BitmapData
    {
      var a:xChar2;
      if (c <= 32) { return null; }
      if (c >= 512) { return null; }
      
      a = vecChar[c];
      if (a == null) { return null; }
      
      return a.sprite;
    }//getchardata
    
    
     public function drawChar(to:BitmapData, cx:Number, cy:Number, ang:Number, str:String,
    colorTransform:ColorTransform=null,blendMode:String=null,smooth:Boolean=false):void
    {
      var a:xChar2;
      var c:int;
      
      c = str.charCodeAt(0);
      if (c <= 32) { return; }
      if (c >= 512) { return; }
      
      a = vecChar[c];
      if (a == null) { return; }
      
      tempMat.identity();
      tempMat.translate(a.width * -0.5, a.height * -0.5);
      tempMat.rotate(ang);
      tempMat.translate(a.width*0.5+cx + a.ox, a.height*0.5+cy + a.oy);
      
      to.draw(a.sprite, tempMat,colorTransform, blendMode, null, smooth);
      
    }//drawchar
    
    
  }//xadvfont  

}

import flash.display.BitmapData;
import flash.geom.Rectangle;

internal class xChar2
{
  public var valid:int = 0;
  public var u0:Number = 0;
  public var v0:Number = 0;
  public var u1:Number = 0;
  public var v1:Number = 0;
  public var width:Number = 0;
  public var height:Number = 0;
  public var rect:Rectangle = new Rectangle();
  //todo -- for coloring the font opengl style
  //each xchar needs to store a bitmapdata
  
  public var addx:Number = 0;
  public var ox:Number = 0;
  public var oy:Number = 0;
  
  public var sprite:BitmapData;
  
}//xchar2  





