package  
{
  import flash.events.Event;
  import flash.media.Sound;
  import flash.media.SoundChannel;
  import flash.media.SoundMixer;
  import flash.media.SoundTransform;
  
  public class xMusMan
  {
    

    public static var emptymus:Sound = new Sound();
    public static var curmus:Sound = emptymus;
    public static var chn:SoundChannel;
    public static var bMute:Boolean = false;
    
        
    public static function playMus(m_:Sound):void
    {
      trace("musman - setmus ");
     
      if (m_ == null)
      {
        //trace("no music was specified - use disable for no music ");
        //update -- stop music instead
        stopMus();
        return;
      }//endif
      
      if (m_ == curmus) 
      {
        trace("this is the music currently played");
        return;
      }//endif
      
      stopMus();
      
      curmus = m_;
      pausePos  = 0; //reset pause position
      
      restartMus(); //start playing
      
      
    }//setmus
    
    //should be called someone else
    public static function disableMus():void
    {
      stopMus();
      curmus = null;
    }//dismus
    
    public static function setMusNone():void
    {
      stopMus();
      curmus = null;
    }//setnone
    
    
    public static function stopMus():void
    {
      if (chn == null) return;
      
      pausePos = 0;
      chn.stop();
      chn = null;
      bPaused = false;
    }//stopmus
    
    public static var volume:Number = 1.0;
    public static var pausePos:Number = 0;
    public static var bPaused:Boolean = false;
    
    
    public static function setVolume(vol:Number=1.0):void
    {
      volume = vol;
      
      if (curmus == null) { return; }
      if (bPaused) { return; }
      
      pauseMus();
      contMus();
      
    }//setvolume
    
    
    public static function pauseMus():void
    {
      if (bPaused == true) { return;  }
      
      trace("pausing music ")
      if (chn == null) return;
    
      pausePos = chn.position;
      
      trace("paused pos " + chn.position);
      
      chn.stop();
      chn = null;
      bPaused = true;
    }//pmus
    
    public static function contMus():void
    {
      trace("continue music -- pos " + pausePos);
      
      if (bPaused == false) { return;  }
      //if (chn == null) { trace("no channel"); return; }
      if (pausePos == -1) { trace("ppos 0"); return;} //still playing
      //if (chn != null) return; //still playing
      if (curmus == null) { trace("curmus 0"); return; }
      if (curmus == emptymus) return; //just use null(?)
      
      if (bMute) {return;} //dont play if sound disabled
      
    //  trace(" reached continue");
      
    
      var t:SoundTransform;
      t = new SoundTransform();
      t.volume = volume;
      t.pan = 0;
    
      chn = curmus.play(pausePos, 1, t);
      chn.addEventListener(Event.SOUND_COMPLETE, musFinished, false, 0, true); 
      //checking for complete is needed or flash is going to start playing
      //from startTime when repeating (and we dont want that here)
      
      pausePos = -1;
            bPaused = false;
    }//contmus
    
    private static function musFinished(e:Event):void
    {
      trace("sound complete -- restarting music");
      restartMus();
    }//musfin
    
    public static function restartMus():void
    {
      //if (bMute) return; //dont play if sound disabled
      if (curmus == null) return;
      
      if (chn != null)
      {
        chn.stop();
        chn = null;
      }//endif
      
      
      var t:SoundTransform;
      t = new SoundTransform();
      t.volume = volume;
      t.pan = 0;
      
     
      
      
      chn = curmus.play(0, 9999999, t);
      pausePos = -1;
      bPaused = false;
      
      
       if (bMute) { pauseMus(); }
    }//remus
    
  }//classend

}